// 标准版匹配字段
const standardMatchFromEnum = {
  protocol: "app_proto",
  method: "method",
  ipAsn: "sip",
  ip: "sip",
  ipCountry: "sip",
  ipArea: "sip",
  directory: "cgi",
  index: "url",
  path: "url",
  file: "cgi",
  referer: "referer",
  userAgent: "ua",
};

// 企业版匹配字段
const enterpriseMatchFromEnum = {
  protocol: "app_proto",
  method: "method",
  ipAsn: "sip",
  ip: "sip",
  ipCountry: "sip",
  ipArea: "sip",
  xForwardFor: "xff",
  directory: "cgi",
  index: "url",
  path: "url",
  file: "cgi",
  referer: "referer",
  cookie: "cookie",
  userAgent: "ua",
  head: "header"
};

// 特殊匹配项条件枚举
const MatchToOperation = {
  ipAsn: {
    equal: "asn_match",
    notequal: "asn_not_match",
  },
  ip: {
    equal: "match",
    notequal: "not_match",
  },
  ipCountry: {
    equal: "include_area",
    notequal: "not_include_area",
  },
  ipArea: {
    equal: "include_area",
    notequal: "not_include_area",
  },
  file: {
    equal:  "file_suffix_match",
    notequal: "file_suffix_not_match",
  },
  directory: {
    equal:  "equal",
    notequal: "not_equal",
    include: "include"
  },
  head: {
    equal:  "equal",
    notequal: "not_equal",
    include: "include",
    exclude: "not_include",
    null: "is_empty"
  }
};

// 匹配关系枚举
const operatorEnum = {
  equal: "equal",
  notequal: "not_equal",
  include: "include",
  exclude: "not_include",
  matching: "match_prefix",
  null: "not_exists",
};

// SCDN to EO Action枚举
const ActionEnum = {
  observe: "monitor",
  intercept: "drop",
  redirect: "redirect",
};

const standardKeys = Object.keys(standardMatchFromEnum);

const enterpriseKeys = Object.keys(enterpriseMatchFromEnum);

module.exports = {
  standardMatchFromEnum,
  enterpriseMatchFromEnum,
  operatorEnum,
  ActionEnum,
  standardKeys,
  enterpriseKeys,
  MatchToOperation,
};
