const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function HostHeaderRewrite(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.Origin.ServerName;
  if (keyConfig === domain) {
    ruleTransferLog.push({
      config: "Host Header重写(HostHeader)",
      result: t("未配置"),
      detail: "",
    });
    genLog.defaultLog(`${t("Host Header重写(HostHeader)")}${t("未配置")}`);

    return null;
  }

  ruleTransferLog.push({
    config: t("Host Header重写(HostHeader)"),
    result: t("成功"),
    detail: "",
  });
  genLog.successLog(`${t("Host Header重写(HostHeader)")}${t("成功")}`);

  return {
    NormalAction: {
      Action: "HostHeader",
      Parameters: [
        {
          Name: "Action",
          Values: ["custom"],
        },
        {
          Name: "ServerName",
          Values: [keyConfig],
        },
      ],
    },
  };
}

module.exports = HostHeaderRewrite;
