const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function Http2(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.Https.Http2;
  if (!keyConfig || keyConfig === 'off') {
    ruleTransferLog.push({
      config: t('HTTP 2.0配置(Https.Http2)'),
      result: t('未配置'),
      detail: ''
    });
    genLog.defaultLog(`${t('HTTP 2.0配置(Https.Http2)')}${t('未配置')}`)
    return null;
  }

  ruleTransferLog.push({
    config: t('HTTP 2.0配置(Https.Http2)'),
    result: t('成功'),
    detail: ''
  });
  genLog.successLog(`${t('HTTP 2.0配置(Https.Http2)')}${t('成功')}`)

  return {
    'NormalAction': {
      'Action': 'Http2',
      'Parameters': [
        {
          'Name': 'Switch',
          'Values': [
            'on'
          ]
        }
      ]
    }
  };
}

module.exports = Http2;