const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function OcspStapling(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.Https.OcspStapling;
  if (!keyConfig || keyConfig === 'off') {
    ruleTransferLog.push({
      config: t('OCSP装订配置(Https.OcspStapling)'),
      result: t('未配置'),
      detail: ''
    });
    genLog.defaultLog(`${t('OCSP装订配置(Https.OcspStapling)')}${t('未配置')}`)
    return null;
  }

  ruleTransferLog.push({
    config: t('OCSP装订配置(Https.OcspStapling)'),
    result: t('成功'),
    detail: ''
  });
  genLog.successLog(`${t('OCSP装订配置(Https.OcspStapling)')}${t('成功')}`)

  return {
    'NormalAction': {
      'Action': 'OcspStapling',
      'Parameters': [
        {
          'Name': 'Switch',
          'Values': [
            'on'
          ]
        }
      ]
    }
  };
}

module.exports = OcspStapling;