const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function OfflineCache(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.OfflineCache;
  if (keyConfig.Switch !== 'on') {
    ruleTransferLog.push({
      config: t('离线缓存配置(OfflineCache)'),
      result: t('未配置'),
      detail: ''
    });
    genLog.defaultLog(`${t('离线缓存配置(OfflineCache)')}${t('未配置')}`)

    return null;
  }

  ruleTransferLog.push({
    config: t('离线缓存配置(OfflineCache)'),
    result: t('成功'),
    detail: ''
  });
  genLog.successLog(`${t('离线缓存配置(OfflineCache)')}${t('成功')}`)

  return {
    'NormalAction': {
      'Action': 'OfflineCache',
      'Parameters': [
        {
          'Name': 'Switch',
          'Values': [
            'on'
          ]
        }
      ]
    }
  };
}

module.exports = OfflineCache;