const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function OriginPullProtocol(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.Origin.OriginPullProtocol;
  if (!keyConfig) {
    ruleTransferLog.push({
      config: t('回源协议配置(Origin.OriginPullProtocol)'),
      result: t('未配置'),
      detail: ''
    });
    genLog.defaultLog(`${t('回源协议配置(Origin.OriginPullProtocol)')}${t('未配置')}`)
    return null;
  }

  ruleTransferLog.push({
    config: t('回源协议配置(Origin.OriginPullProtocol)'),
    result: t('成功'),
    detail: ''
  });
  genLog.successLog(`${t('回源协议配置(Origin.OriginPullProtocol)')}${t('成功')}`)

  return {
    'NormalAction': {
      'Action': 'OriginPullProtocol',
      'Parameters': [
        {
          'Name': 'Protocol',
          'Values': [keyConfig]
        }
      ]
    }
  };

}

module.exports = OriginPullProtocol;