const { t } = require("../../i18n/trans");

function OriginPullTimeout(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.OriginPullTimeout;
  const responseTimeout = keyConfig.ReceiveTimeout;
  if (!keyConfig || !responseTimeout) {
    ruleTransferLog.push({
      config: t("回源超时时间(HTTPUpstreamTimeout)"),
      result: t("未配置"),
      detail: "",
    });
    return null;
  }

  ruleTransferLog.push({
    config: t("回源超时时间(HTTPUpstreamTimeout)"),
    result: t("成功"),
    detail: "",
  });

  return {
    NormalAction: {
      Action: "HTTPUpstreamTimeout",
      Parameters: [
        {
          Name: "ResponseTimeout",
          Values: [responseTimeout.toString()],
        },
      ],
    },
  };
}

module.exports = OriginPullTimeout;
