const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function Quic(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.Quic;
  if (keyConfig.Switch !== 'on') {
    ruleTransferLog.push({
      config: t('Quic配置(Quic)'),
      result: t('未配置'),
      detail: ''
    });
    genLog.defaultLog(`${t('Quic配置(Quic)')}${t('未配置')}`)
    return null;
  }

  ruleTransferLog.push({
    config: t('Quic配置(Quic)'),
    result: t('成功'),
    detail: ''
  });
  genLog.successLog(`${t('Quic配置(Quic)')}${t('成功')}`)

  return {
    'NormalAction': {
      'Action': 'Quic',
      'Parameters': [
        {
          'Name': 'Switch',
          'Values': [
            'on'
          ]
        }
      ]
    }
  };
}

module.exports = Quic;