const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function StatusCodeCache(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.StatusCodeCache;
  if (!keyConfig || !keyConfig.CacheRules || !keyConfig.CacheRules.length || keyConfig.Switch !== 'on') {
    ruleTransferLog.push({
      config: t('状态码缓存配置(StatusCodeCache)'),
      result: t('未配置'),
      detail: ''
    });
    genLog.defaultLog(`${t('状态码缓存配置(StatusCodeCache)')}${t('未配置')}`)

    return null;
  }
  const { CacheRules } = keyConfig;
  ruleTransferLog.push({
    config: t('状态码缓存配置(StatusCodeCache)'),
    result: t('成功'),
    detail: ''
  });
  genLog.successLog(`${t('状态码缓存配置(StatusCodeCache)')}${t('成功')}`)
  return {
    'CodeAction': {
      'Action': 'StatusCodeCache',
      'Parameters': CacheRules.map(rule => {
        return {
          Name: 'CacheTime',
          StatusCode: Number(rule.StatusCode),
          Values: [
            String(rule.CacheTime)
          ]
        };
      })
    }
  };
}

module.exports = StatusCodeCache

