const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function TlsVersion(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.Https.TlsVersion;
  if (!keyConfig) {
    ruleTransferLog.push({
      config: t('TLS版本配置(Https.TlsVersion)'),
      result: t('未配置'),
      detail: ''
    });
    genLog.defaultLog(`${t('TLS版本配置(Https.TlsVersion)')}${t('未配置')}`)
    return null;
  }

  ruleTransferLog.push({
    config: t('TLS版本配置(Https.TlsVersion)'),
    result: t('成功'),
    detail: ''
  });
  genLog.successLog(`${t('TLS版本配置(Https.TlsVersion)')}${t('成功')}`)

  return {
    'NormalAction': {
      'Action': 'SslTlsSecureConf',
      'Parameters': [
        {
          'Name': 'TlsVersion',
          'Values': keyConfig
        },
        {
          'Name': 'CipherSuite',
          'Values': [
            'loose-v2023'
          ]
        }
      ]
    }
  };
}

module.exports = TlsVersion;