const { t } = require("../../i18n/trans");
const genLog = require("../../logGenerator");

function WebSocket(domain, domainConfig, ruleTransferLog) {
  const keyConfig = domainConfig.WebSocket;
  if (keyConfig.Switch !== 'on') {
    ruleTransferLog.push({
      config: t('WebSocket配置(WebSocket)'),
      result: t('未配置'),
      detail: ''
    });
    genLog.defaultLog(`${t('WebSocket配置(WebSocket)')}${t('未配置')}`)

    return null;
  }

  ruleTransferLog.push({
    config: t('WebSocket配置(WebSocket)'),
    result: t('成功'),
    detail: ''
  });
  genLog.successLog(`${t('WebSocket配置(WebSocket)')}${t('成功')}`)

  return {
    'NormalAction': {
      'Action': 'WebSocket',
      'Parameters': [
        {
          'Name': 'Switch',
          'Values': [
            'on'
          ]
        },
        {
          'Name': 'Timeout',
          'Values': [String(keyConfig.Timeout)]
        }
      ]
    }
  };
}

module.exports = WebSocket;